<?php namespace DSTU_TWO;

/*!
 * This class was generated with the PHPFHIR library (https://github.com/dcarbone/php-fhir) using
 * class definitions from HL7 FHIR (https://www.hl7.org/fhir/)
 * 
 * Class creation date: May 13th, 2016
 * 
 * PHPFHIR Copyright:
 * 
 * Copyright 2016 Daniel Carbone (daniel.p.carbone@gmail.com)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *        http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

class PHPFHIRAutoloader
{
    const ROOT_DIR = __DIR__;

    /** @var array */
    private static $_classMap = array (
  'DSTU_TWO\\PHPFHIRParserMap' => 'PHPFHIRParserMap.php',
  'DSTU_TWO\\JsonSerializable' => 'JsonSerializable.php',
  'DSTU_TWO\\FHIRElement\\FHIRMarkdown' => 'FHIRElement/FHIRMarkdown.php',
  'DSTU_TWO\\FHIRElement\\FHIRInteger' => 'FHIRElement/FHIRInteger.php',
  'DSTU_TWO\\FHIRElement\\FHIRDateTime' => 'FHIRElement/FHIRDateTime.php',
  'DSTU_TWO\\FHIRElement\\FHIRUnsignedInt' => 'FHIRElement/FHIRUnsignedInt.php',
  'DSTU_TWO\\FHIRElement\\FHIRCode' => 'FHIRElement/FHIRCode.php',
  'DSTU_TWO\\FHIRElement\\FHIRDate' => 'FHIRElement/FHIRDate.php',
  'DSTU_TWO\\FHIRElement\\FHIRDecimal' => 'FHIRElement/FHIRDecimal.php',
  'DSTU_TWO\\FHIRElement\\FHIRUri' => 'FHIRElement/FHIRUri.php',
  'DSTU_TWO\\FHIRElement\\FHIRId' => 'FHIRElement/FHIRId.php',
  'DSTU_TWO\\FHIRElement\\FHIRBase64Binary' => 'FHIRElement/FHIRBase64Binary.php',
  'DSTU_TWO\\FHIRElement\\FHIRTime' => 'FHIRElement/FHIRTime.php',
  'DSTU_TWO\\FHIRElement\\FHIROid' => 'FHIRElement/FHIROid.php',
  'DSTU_TWO\\FHIRElement\\FHIRPositiveInt' => 'FHIRElement/FHIRPositiveInt.php',
  'DSTU_TWO\\FHIRElement\\FHIRString' => 'FHIRElement/FHIRString.php',
  'DSTU_TWO\\FHIRElement\\FHIRBoolean' => 'FHIRElement/FHIRBoolean.php',
  'DSTU_TWO\\FHIRElement\\FHIRUuid' => 'FHIRElement/FHIRUuid.php',
  'DSTU_TWO\\FHIRElement\\FHIRInstant' => 'FHIRElement/FHIRInstant.php',
  'DSTU_TWO\\FHIRResourceContainer' => 'FHIRResourceContainer.php',
  'DSTU_TWO\\FHIRElement\\FHIRExtension' => 'FHIRElement/FHIRExtension.php',
  'DSTU_TWO\\FHIRElement\\FHIRBackboneElement' => 'FHIRElement/FHIRBackboneElement.php',
  'DSTU_TWO\\FHIRElement\\FHIRNarrative' => 'FHIRElement/FHIRNarrative.php',
  'DSTU_TWO\\FHIRElement\\FHIRNarrativeStatus' => 'FHIRElement/FHIRNarrativeStatus.php',
  'DSTU_TWO\\FHIRElement' => 'FHIRElement.php',
  'DSTU_TWO\\FHIRElement\\FHIRPeriod' => 'FHIRElement/FHIRPeriod.php',
  'DSTU_TWO\\FHIRElement\\FHIRCoding' => 'FHIRElement/FHIRCoding.php',
  'DSTU_TWO\\FHIRElement\\FHIRRange' => 'FHIRElement/FHIRRange.php',
  'DSTU_TWO\\FHIRElement\\FHIRQuantity' => 'FHIRElement/FHIRQuantity.php',
  'DSTU_TWO\\FHIRElement\\FHIRQuantityComparator' => 'FHIRElement/FHIRQuantityComparator.php',
  'DSTU_TWO\\FHIRElement\\FHIRAttachment' => 'FHIRElement/FHIRAttachment.php',
  'DSTU_TWO\\FHIRElement\\FHIRRatio' => 'FHIRElement/FHIRRatio.php',
  'DSTU_TWO\\FHIRElement\\FHIRAnnotation' => 'FHIRElement/FHIRAnnotation.php',
  'DSTU_TWO\\FHIRElement\\FHIRSampledData' => 'FHIRElement/FHIRSampledData.php',
  'DSTU_TWO\\FHIRElement\\FHIRSampledDataDataType' => 'FHIRElement/FHIRSampledDataDataType.php',
  'DSTU_TWO\\FHIRElement\\FHIRReference' => 'FHIRElement/FHIRReference.php',
  'DSTU_TWO\\FHIRElement\\FHIRCodeableConcept' => 'FHIRElement/FHIRCodeableConcept.php',
  'DSTU_TWO\\FHIRElement\\FHIRIdentifier' => 'FHIRElement/FHIRIdentifier.php',
  'DSTU_TWO\\FHIRElement\\FHIRIdentifierUse' => 'FHIRElement/FHIRIdentifierUse.php',
  'DSTU_TWO\\FHIRElement\\FHIRSignature' => 'FHIRElement/FHIRSignature.php',
  'DSTU_TWO\\FHIRAge' => 'FHIRAge.php',
  'DSTU_TWO\\FHIRCount' => 'FHIRCount.php',
  'DSTU_TWO\\FHIRMoney' => 'FHIRMoney.php',
  'DSTU_TWO\\FHIRDistance' => 'FHIRDistance.php',
  'DSTU_TWO\\FHIRDuration' => 'FHIRDuration.php',
  'DSTU_TWO\\FHIRSimpleQuantity' => 'FHIRSimpleQuantity.php',
  'DSTU_TWO\\FHIRElement\\FHIRElementDefinition' => 'FHIRElement/FHIRElementDefinition.php',
  'DSTU_TWO\\FHIRResource\\FHIRElementDefinition\\FHIRElementDefinitionMapping' => 'FHIRResource/FHIRElementDefinition/FHIRElementDefinitionMapping.php',
  'DSTU_TWO\\FHIRResource\\FHIRElementDefinition\\FHIRElementDefinitionSlicing' => 'FHIRResource/FHIRElementDefinition/FHIRElementDefinitionSlicing.php',
  'DSTU_TWO\\FHIRResource\\FHIRElementDefinition\\FHIRElementDefinitionBinding' => 'FHIRResource/FHIRElementDefinition/FHIRElementDefinitionBinding.php',
  'DSTU_TWO\\FHIRResource\\FHIRElementDefinition\\FHIRElementDefinitionType' => 'FHIRResource/FHIRElementDefinition/FHIRElementDefinitionType.php',
  'DSTU_TWO\\FHIRResource\\FHIRElementDefinition\\FHIRElementDefinitionBase' => 'FHIRResource/FHIRElementDefinition/FHIRElementDefinitionBase.php',
  'DSTU_TWO\\FHIRResource\\FHIRElementDefinition\\FHIRElementDefinitionConstraint' => 'FHIRResource/FHIRElementDefinition/FHIRElementDefinitionConstraint.php',
  'DSTU_TWO\\FHIRElement\\FHIRPropertyRepresentation' => 'FHIRElement/FHIRPropertyRepresentation.php',
  'DSTU_TWO\\FHIRElement\\FHIRSlicingRules' => 'FHIRElement/FHIRSlicingRules.php',
  'DSTU_TWO\\FHIRElement\\FHIRBindingStrength' => 'FHIRElement/FHIRBindingStrength.php',
  'DSTU_TWO\\FHIRElement\\FHIRAggregationMode' => 'FHIRElement/FHIRAggregationMode.php',
  'DSTU_TWO\\FHIRElement\\FHIRConstraintSeverity' => 'FHIRElement/FHIRConstraintSeverity.php',
  'DSTU_TWO\\FHIRElement\\FHIRTiming' => 'FHIRElement/FHIRTiming.php',
  'DSTU_TWO\\FHIRResource\\FHIRTiming\\FHIRTimingRepeat' => 'FHIRResource/FHIRTiming/FHIRTimingRepeat.php',
  'DSTU_TWO\\FHIRElement\\FHIRUnitsOfTime' => 'FHIRElement/FHIRUnitsOfTime.php',
  'DSTU_TWO\\FHIRElement\\FHIREventTiming' => 'FHIRElement/FHIREventTiming.php',
  'DSTU_TWO\\FHIRElement\\FHIRAddress' => 'FHIRElement/FHIRAddress.php',
  'DSTU_TWO\\FHIRElement\\FHIRAddressUse' => 'FHIRElement/FHIRAddressUse.php',
  'DSTU_TWO\\FHIRElement\\FHIRAddressType' => 'FHIRElement/FHIRAddressType.php',
  'DSTU_TWO\\FHIRElement\\FHIRHumanName' => 'FHIRElement/FHIRHumanName.php',
  'DSTU_TWO\\FHIRElement\\FHIRNameUse' => 'FHIRElement/FHIRNameUse.php',
  'DSTU_TWO\\FHIRElement\\FHIRMeta' => 'FHIRElement/FHIRMeta.php',
  'DSTU_TWO\\FHIRElement\\FHIRContactPoint' => 'FHIRElement/FHIRContactPoint.php',
  'DSTU_TWO\\FHIRElement\\FHIRContactPointSystem' => 'FHIRElement/FHIRContactPointSystem.php',
  'DSTU_TWO\\FHIRElement\\FHIRContactPointUse' => 'FHIRElement/FHIRContactPointUse.php',
  'DSTU_TWO\\FHIRResource' => 'FHIRResource.php',
  'DSTU_TWO\\FHIRResource\\FHIRDomainResource' => 'FHIRResource/FHIRDomainResource.php',
  'DSTU_TWO\\FHIRElement\\FHIRNoteType' => 'FHIRElement/FHIRNoteType.php',
  'DSTU_TWO\\FHIRElement\\FHIRDocumentReferenceStatus' => 'FHIRElement/FHIRDocumentReferenceStatus.php',
  'DSTU_TWO\\FHIRElement\\FHIRConceptMapEquivalence' => 'FHIRElement/FHIRConceptMapEquivalence.php',
  'DSTU_TWO\\FHIRElement\\FHIRRemittanceOutcome' => 'FHIRElement/FHIRRemittanceOutcome.php',
  'DSTU_TWO\\FHIRElement\\FHIRConformanceResourceStatus' => 'FHIRElement/FHIRConformanceResourceStatus.php',
  'DSTU_TWO\\FHIRElement\\FHIRAdministrativeGender' => 'FHIRElement/FHIRAdministrativeGender.php',
  'DSTU_TWO\\FHIRElement\\FHIRSearchParamType' => 'FHIRElement/FHIRSearchParamType.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRAccount' => 'FHIRDomainResource/FHIRAccount.php',
  'DSTU_TWO\\FHIRElement\\FHIRAccountStatus' => 'FHIRElement/FHIRAccountStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRAllergyIntolerance' => 'FHIRDomainResource/FHIRAllergyIntolerance.php',
  'DSTU_TWO\\FHIRResource\\FHIRAllergyIntolerance\\FHIRAllergyIntoleranceReaction' => 'FHIRResource/FHIRAllergyIntolerance/FHIRAllergyIntoleranceReaction.php',
  'DSTU_TWO\\FHIRElement\\FHIRAllergyIntoleranceCertainty' => 'FHIRElement/FHIRAllergyIntoleranceCertainty.php',
  'DSTU_TWO\\FHIRElement\\FHIRAllergyIntoleranceType' => 'FHIRElement/FHIRAllergyIntoleranceType.php',
  'DSTU_TWO\\FHIRElement\\FHIRAllergyIntoleranceSeverity' => 'FHIRElement/FHIRAllergyIntoleranceSeverity.php',
  'DSTU_TWO\\FHIRElement\\FHIRAllergyIntoleranceCriticality' => 'FHIRElement/FHIRAllergyIntoleranceCriticality.php',
  'DSTU_TWO\\FHIRElement\\FHIRAllergyIntoleranceCategory' => 'FHIRElement/FHIRAllergyIntoleranceCategory.php',
  'DSTU_TWO\\FHIRElement\\FHIRAllergyIntoleranceStatus' => 'FHIRElement/FHIRAllergyIntoleranceStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRAppointment' => 'FHIRDomainResource/FHIRAppointment.php',
  'DSTU_TWO\\FHIRResource\\FHIRAppointment\\FHIRAppointmentParticipant' => 'FHIRResource/FHIRAppointment/FHIRAppointmentParticipant.php',
  'DSTU_TWO\\FHIRElement\\FHIRParticipantRequired' => 'FHIRElement/FHIRParticipantRequired.php',
  'DSTU_TWO\\FHIRElement\\FHIRAppointmentStatus' => 'FHIRElement/FHIRAppointmentStatus.php',
  'DSTU_TWO\\FHIRElement\\FHIRParticipationStatus' => 'FHIRElement/FHIRParticipationStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRAppointmentResponse' => 'FHIRDomainResource/FHIRAppointmentResponse.php',
  'DSTU_TWO\\FHIRElement\\FHIRParticipantStatus' => 'FHIRElement/FHIRParticipantStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRAuditEvent' => 'FHIRDomainResource/FHIRAuditEvent.php',
  'DSTU_TWO\\FHIRResource\\FHIRAuditEvent\\FHIRAuditEventEvent' => 'FHIRResource/FHIRAuditEvent/FHIRAuditEventEvent.php',
  'DSTU_TWO\\FHIRResource\\FHIRAuditEvent\\FHIRAuditEventParticipant' => 'FHIRResource/FHIRAuditEvent/FHIRAuditEventParticipant.php',
  'DSTU_TWO\\FHIRResource\\FHIRAuditEvent\\FHIRAuditEventNetwork' => 'FHIRResource/FHIRAuditEvent/FHIRAuditEventNetwork.php',
  'DSTU_TWO\\FHIRResource\\FHIRAuditEvent\\FHIRAuditEventSource' => 'FHIRResource/FHIRAuditEvent/FHIRAuditEventSource.php',
  'DSTU_TWO\\FHIRResource\\FHIRAuditEvent\\FHIRAuditEventObject' => 'FHIRResource/FHIRAuditEvent/FHIRAuditEventObject.php',
  'DSTU_TWO\\FHIRResource\\FHIRAuditEvent\\FHIRAuditEventDetail' => 'FHIRResource/FHIRAuditEvent/FHIRAuditEventDetail.php',
  'DSTU_TWO\\FHIRElement\\FHIRAuditEventAction' => 'FHIRElement/FHIRAuditEventAction.php',
  'DSTU_TWO\\FHIRElement\\FHIRAuditEventOutcome' => 'FHIRElement/FHIRAuditEventOutcome.php',
  'DSTU_TWO\\FHIRElement\\FHIRAuditEventParticipantNetworkType' => 'FHIRElement/FHIRAuditEventParticipantNetworkType.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRBasic' => 'FHIRDomainResource/FHIRBasic.php',
  'DSTU_TWO\\FHIRResource\\FHIRBinary' => 'FHIRResource/FHIRBinary.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRBodySite' => 'FHIRDomainResource/FHIRBodySite.php',
  'DSTU_TWO\\FHIRResource\\FHIRBundle' => 'FHIRResource/FHIRBundle.php',
  'DSTU_TWO\\FHIRResource\\FHIRBundle\\FHIRBundleLink' => 'FHIRResource/FHIRBundle/FHIRBundleLink.php',
  'DSTU_TWO\\FHIRResource\\FHIRBundle\\FHIRBundleEntry' => 'FHIRResource/FHIRBundle/FHIRBundleEntry.php',
  'DSTU_TWO\\FHIRResource\\FHIRBundle\\FHIRBundleSearch' => 'FHIRResource/FHIRBundle/FHIRBundleSearch.php',
  'DSTU_TWO\\FHIRResource\\FHIRBundle\\FHIRBundleRequest' => 'FHIRResource/FHIRBundle/FHIRBundleRequest.php',
  'DSTU_TWO\\FHIRResource\\FHIRBundle\\FHIRBundleResponse' => 'FHIRResource/FHIRBundle/FHIRBundleResponse.php',
  'DSTU_TWO\\FHIRElement\\FHIRHTTPVerb' => 'FHIRElement/FHIRHTTPVerb.php',
  'DSTU_TWO\\FHIRElement\\FHIRSearchEntryMode' => 'FHIRElement/FHIRSearchEntryMode.php',
  'DSTU_TWO\\FHIRElement\\FHIRBundleType' => 'FHIRElement/FHIRBundleType.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRCarePlan' => 'FHIRDomainResource/FHIRCarePlan.php',
  'DSTU_TWO\\FHIRResource\\FHIRCarePlan\\FHIRCarePlanRelatedPlan' => 'FHIRResource/FHIRCarePlan/FHIRCarePlanRelatedPlan.php',
  'DSTU_TWO\\FHIRResource\\FHIRCarePlan\\FHIRCarePlanParticipant' => 'FHIRResource/FHIRCarePlan/FHIRCarePlanParticipant.php',
  'DSTU_TWO\\FHIRResource\\FHIRCarePlan\\FHIRCarePlanActivity' => 'FHIRResource/FHIRCarePlan/FHIRCarePlanActivity.php',
  'DSTU_TWO\\FHIRResource\\FHIRCarePlan\\FHIRCarePlanDetail' => 'FHIRResource/FHIRCarePlan/FHIRCarePlanDetail.php',
  'DSTU_TWO\\FHIRElement\\FHIRCarePlanStatus' => 'FHIRElement/FHIRCarePlanStatus.php',
  'DSTU_TWO\\FHIRElement\\FHIRCarePlanRelationship' => 'FHIRElement/FHIRCarePlanRelationship.php',
  'DSTU_TWO\\FHIRElement\\FHIRCarePlanActivityStatus' => 'FHIRElement/FHIRCarePlanActivityStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRClaim' => 'FHIRDomainResource/FHIRClaim.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaim\\FHIRClaimPayee' => 'FHIRResource/FHIRClaim/FHIRClaimPayee.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaim\\FHIRClaimDiagnosis' => 'FHIRResource/FHIRClaim/FHIRClaimDiagnosis.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaim\\FHIRClaimCoverage' => 'FHIRResource/FHIRClaim/FHIRClaimCoverage.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaim\\FHIRClaimItem' => 'FHIRResource/FHIRClaim/FHIRClaimItem.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaim\\FHIRClaimDetail' => 'FHIRResource/FHIRClaim/FHIRClaimDetail.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaim\\FHIRClaimSubDetail' => 'FHIRResource/FHIRClaim/FHIRClaimSubDetail.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaim\\FHIRClaimProsthesis' => 'FHIRResource/FHIRClaim/FHIRClaimProsthesis.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaim\\FHIRClaimMissingTeeth' => 'FHIRResource/FHIRClaim/FHIRClaimMissingTeeth.php',
  'DSTU_TWO\\FHIRElement\\FHIRClaimType' => 'FHIRElement/FHIRClaimType.php',
  'DSTU_TWO\\FHIRElement\\FHIRUse' => 'FHIRElement/FHIRUse.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRClaimResponse' => 'FHIRDomainResource/FHIRClaimResponse.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaimResponse\\FHIRClaimResponseItem' => 'FHIRResource/FHIRClaimResponse/FHIRClaimResponseItem.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaimResponse\\FHIRClaimResponseAdjudication' => 'FHIRResource/FHIRClaimResponse/FHIRClaimResponseAdjudication.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaimResponse\\FHIRClaimResponseDetail' => 'FHIRResource/FHIRClaimResponse/FHIRClaimResponseDetail.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaimResponse\\FHIRClaimResponseAdjudication1' => 'FHIRResource/FHIRClaimResponse/FHIRClaimResponseAdjudication1.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaimResponse\\FHIRClaimResponseSubDetail' => 'FHIRResource/FHIRClaimResponse/FHIRClaimResponseSubDetail.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaimResponse\\FHIRClaimResponseAdjudication2' => 'FHIRResource/FHIRClaimResponse/FHIRClaimResponseAdjudication2.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaimResponse\\FHIRClaimResponseAddItem' => 'FHIRResource/FHIRClaimResponse/FHIRClaimResponseAddItem.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaimResponse\\FHIRClaimResponseAdjudication3' => 'FHIRResource/FHIRClaimResponse/FHIRClaimResponseAdjudication3.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaimResponse\\FHIRClaimResponseDetail1' => 'FHIRResource/FHIRClaimResponse/FHIRClaimResponseDetail1.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaimResponse\\FHIRClaimResponseAdjudication4' => 'FHIRResource/FHIRClaimResponse/FHIRClaimResponseAdjudication4.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaimResponse\\FHIRClaimResponseError' => 'FHIRResource/FHIRClaimResponse/FHIRClaimResponseError.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaimResponse\\FHIRClaimResponseNote' => 'FHIRResource/FHIRClaimResponse/FHIRClaimResponseNote.php',
  'DSTU_TWO\\FHIRResource\\FHIRClaimResponse\\FHIRClaimResponseCoverage' => 'FHIRResource/FHIRClaimResponse/FHIRClaimResponseCoverage.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRClinicalImpression' => 'FHIRDomainResource/FHIRClinicalImpression.php',
  'DSTU_TWO\\FHIRResource\\FHIRClinicalImpression\\FHIRClinicalImpressionInvestigations' => 'FHIRResource/FHIRClinicalImpression/FHIRClinicalImpressionInvestigations.php',
  'DSTU_TWO\\FHIRResource\\FHIRClinicalImpression\\FHIRClinicalImpressionFinding' => 'FHIRResource/FHIRClinicalImpression/FHIRClinicalImpressionFinding.php',
  'DSTU_TWO\\FHIRResource\\FHIRClinicalImpression\\FHIRClinicalImpressionRuledOut' => 'FHIRResource/FHIRClinicalImpression/FHIRClinicalImpressionRuledOut.php',
  'DSTU_TWO\\FHIRElement\\FHIRClinicalImpressionStatus' => 'FHIRElement/FHIRClinicalImpressionStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRCommunication' => 'FHIRDomainResource/FHIRCommunication.php',
  'DSTU_TWO\\FHIRResource\\FHIRCommunication\\FHIRCommunicationPayload' => 'FHIRResource/FHIRCommunication/FHIRCommunicationPayload.php',
  'DSTU_TWO\\FHIRElement\\FHIRCommunicationStatus' => 'FHIRElement/FHIRCommunicationStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRCommunicationRequest' => 'FHIRDomainResource/FHIRCommunicationRequest.php',
  'DSTU_TWO\\FHIRResource\\FHIRCommunicationRequest\\FHIRCommunicationRequestPayload' => 'FHIRResource/FHIRCommunicationRequest/FHIRCommunicationRequestPayload.php',
  'DSTU_TWO\\FHIRElement\\FHIRCommunicationRequestStatus' => 'FHIRElement/FHIRCommunicationRequestStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRComposition' => 'FHIRDomainResource/FHIRComposition.php',
  'DSTU_TWO\\FHIRResource\\FHIRComposition\\FHIRCompositionAttester' => 'FHIRResource/FHIRComposition/FHIRCompositionAttester.php',
  'DSTU_TWO\\FHIRResource\\FHIRComposition\\FHIRCompositionEvent' => 'FHIRResource/FHIRComposition/FHIRCompositionEvent.php',
  'DSTU_TWO\\FHIRResource\\FHIRComposition\\FHIRCompositionSection' => 'FHIRResource/FHIRComposition/FHIRCompositionSection.php',
  'DSTU_TWO\\FHIRElement\\FHIRCompositionStatus' => 'FHIRElement/FHIRCompositionStatus.php',
  'DSTU_TWO\\FHIRElement\\FHIRCompositionAttestationMode' => 'FHIRElement/FHIRCompositionAttestationMode.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRConceptMap' => 'FHIRDomainResource/FHIRConceptMap.php',
  'DSTU_TWO\\FHIRResource\\FHIRConceptMap\\FHIRConceptMapContact' => 'FHIRResource/FHIRConceptMap/FHIRConceptMapContact.php',
  'DSTU_TWO\\FHIRResource\\FHIRConceptMap\\FHIRConceptMapElement' => 'FHIRResource/FHIRConceptMap/FHIRConceptMapElement.php',
  'DSTU_TWO\\FHIRResource\\FHIRConceptMap\\FHIRConceptMapTarget' => 'FHIRResource/FHIRConceptMap/FHIRConceptMapTarget.php',
  'DSTU_TWO\\FHIRResource\\FHIRConceptMap\\FHIRConceptMapDependsOn' => 'FHIRResource/FHIRConceptMap/FHIRConceptMapDependsOn.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRCondition' => 'FHIRDomainResource/FHIRCondition.php',
  'DSTU_TWO\\FHIRResource\\FHIRCondition\\FHIRConditionStage' => 'FHIRResource/FHIRCondition/FHIRConditionStage.php',
  'DSTU_TWO\\FHIRResource\\FHIRCondition\\FHIRConditionEvidence' => 'FHIRResource/FHIRCondition/FHIRConditionEvidence.php',
  'DSTU_TWO\\FHIRElement\\FHIRConditionVerificationStatus' => 'FHIRElement/FHIRConditionVerificationStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRConditionDefinition' => 'FHIRDomainResource/FHIRConditionDefinition.php',
  'DSTU_TWO\\FHIRResource\\FHIRConditionDefinition\\FHIRConditionDefinitionContact' => 'FHIRResource/FHIRConditionDefinition/FHIRConditionDefinitionContact.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRConformance' => 'FHIRDomainResource/FHIRConformance.php',
  'DSTU_TWO\\FHIRResource\\FHIRConformance\\FHIRConformanceContact' => 'FHIRResource/FHIRConformance/FHIRConformanceContact.php',
  'DSTU_TWO\\FHIRResource\\FHIRConformance\\FHIRConformanceSoftware' => 'FHIRResource/FHIRConformance/FHIRConformanceSoftware.php',
  'DSTU_TWO\\FHIRResource\\FHIRConformance\\FHIRConformanceImplementation' => 'FHIRResource/FHIRConformance/FHIRConformanceImplementation.php',
  'DSTU_TWO\\FHIRResource\\FHIRConformance\\FHIRConformanceRest' => 'FHIRResource/FHIRConformance/FHIRConformanceRest.php',
  'DSTU_TWO\\FHIRResource\\FHIRConformance\\FHIRConformanceSecurity' => 'FHIRResource/FHIRConformance/FHIRConformanceSecurity.php',
  'DSTU_TWO\\FHIRResource\\FHIRConformance\\FHIRConformanceCertificate' => 'FHIRResource/FHIRConformance/FHIRConformanceCertificate.php',
  'DSTU_TWO\\FHIRResource\\FHIRConformance\\FHIRConformanceResource' => 'FHIRResource/FHIRConformance/FHIRConformanceResource.php',
  'DSTU_TWO\\FHIRResource\\FHIRConformance\\FHIRConformanceInteraction' => 'FHIRResource/FHIRConformance/FHIRConformanceInteraction.php',
  'DSTU_TWO\\FHIRResource\\FHIRConformance\\FHIRConformanceSearchParam' => 'FHIRResource/FHIRConformance/FHIRConformanceSearchParam.php',
  'DSTU_TWO\\FHIRResource\\FHIRConformance\\FHIRConformanceInteraction1' => 'FHIRResource/FHIRConformance/FHIRConformanceInteraction1.php',
  'DSTU_TWO\\FHIRResource\\FHIRConformance\\FHIRConformanceOperation' => 'FHIRResource/FHIRConformance/FHIRConformanceOperation.php',
  'DSTU_TWO\\FHIRResource\\FHIRConformance\\FHIRConformanceMessaging' => 'FHIRResource/FHIRConformance/FHIRConformanceMessaging.php',
  'DSTU_TWO\\FHIRResource\\FHIRConformance\\FHIRConformanceEndpoint' => 'FHIRResource/FHIRConformance/FHIRConformanceEndpoint.php',
  'DSTU_TWO\\FHIRResource\\FHIRConformance\\FHIRConformanceEvent' => 'FHIRResource/FHIRConformance/FHIRConformanceEvent.php',
  'DSTU_TWO\\FHIRResource\\FHIRConformance\\FHIRConformanceDocument' => 'FHIRResource/FHIRConformance/FHIRConformanceDocument.php',
  'DSTU_TWO\\FHIRElement\\FHIRDocumentMode' => 'FHIRElement/FHIRDocumentMode.php',
  'DSTU_TWO\\FHIRElement\\FHIRSystemRestfulInteraction' => 'FHIRElement/FHIRSystemRestfulInteraction.php',
  'DSTU_TWO\\FHIRElement\\FHIRResourceVersionPolicy' => 'FHIRElement/FHIRResourceVersionPolicy.php',
  'DSTU_TWO\\FHIRElement\\FHIRRestfulConformanceMode' => 'FHIRElement/FHIRRestfulConformanceMode.php',
  'DSTU_TWO\\FHIRElement\\FHIRTypeRestfulInteraction' => 'FHIRElement/FHIRTypeRestfulInteraction.php',
  'DSTU_TWO\\FHIRElement\\FHIRConditionalDeleteStatus' => 'FHIRElement/FHIRConditionalDeleteStatus.php',
  'DSTU_TWO\\FHIRElement\\FHIRConformanceStatementKind' => 'FHIRElement/FHIRConformanceStatementKind.php',
  'DSTU_TWO\\FHIRElement\\FHIRSearchModifierCode' => 'FHIRElement/FHIRSearchModifierCode.php',
  'DSTU_TWO\\FHIRElement\\FHIRConformanceEventMode' => 'FHIRElement/FHIRConformanceEventMode.php',
  'DSTU_TWO\\FHIRElement\\FHIRMessageSignificanceCategory' => 'FHIRElement/FHIRMessageSignificanceCategory.php',
  'DSTU_TWO\\FHIRElement\\FHIRUnknownContentCode' => 'FHIRElement/FHIRUnknownContentCode.php',
  'DSTU_TWO\\FHIRElement\\FHIRTransactionMode' => 'FHIRElement/FHIRTransactionMode.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRContract' => 'FHIRDomainResource/FHIRContract.php',
  'DSTU_TWO\\FHIRResource\\FHIRContract\\FHIRContractActor' => 'FHIRResource/FHIRContract/FHIRContractActor.php',
  'DSTU_TWO\\FHIRResource\\FHIRContract\\FHIRContractValuedItem' => 'FHIRResource/FHIRContract/FHIRContractValuedItem.php',
  'DSTU_TWO\\FHIRResource\\FHIRContract\\FHIRContractSigner' => 'FHIRResource/FHIRContract/FHIRContractSigner.php',
  'DSTU_TWO\\FHIRResource\\FHIRContract\\FHIRContractTerm' => 'FHIRResource/FHIRContract/FHIRContractTerm.php',
  'DSTU_TWO\\FHIRResource\\FHIRContract\\FHIRContractActor1' => 'FHIRResource/FHIRContract/FHIRContractActor1.php',
  'DSTU_TWO\\FHIRResource\\FHIRContract\\FHIRContractValuedItem1' => 'FHIRResource/FHIRContract/FHIRContractValuedItem1.php',
  'DSTU_TWO\\FHIRResource\\FHIRContract\\FHIRContractFriendly' => 'FHIRResource/FHIRContract/FHIRContractFriendly.php',
  'DSTU_TWO\\FHIRResource\\FHIRContract\\FHIRContractLegal' => 'FHIRResource/FHIRContract/FHIRContractLegal.php',
  'DSTU_TWO\\FHIRResource\\FHIRContract\\FHIRContractRule' => 'FHIRResource/FHIRContract/FHIRContractRule.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRContraindication' => 'FHIRDomainResource/FHIRContraindication.php',
  'DSTU_TWO\\FHIRResource\\FHIRContraindication\\FHIRContraindicationMitigation' => 'FHIRResource/FHIRContraindication/FHIRContraindicationMitigation.php',
  'DSTU_TWO\\FHIRElement\\FHIRContraindicationSeverity' => 'FHIRElement/FHIRContraindicationSeverity.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRCoverage' => 'FHIRDomainResource/FHIRCoverage.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRDataElement' => 'FHIRDomainResource/FHIRDataElement.php',
  'DSTU_TWO\\FHIRResource\\FHIRDataElement\\FHIRDataElementContact' => 'FHIRResource/FHIRDataElement/FHIRDataElementContact.php',
  'DSTU_TWO\\FHIRResource\\FHIRDataElement\\FHIRDataElementMapping' => 'FHIRResource/FHIRDataElement/FHIRDataElementMapping.php',
  'DSTU_TWO\\FHIRElement\\FHIRDataElementStringency' => 'FHIRElement/FHIRDataElementStringency.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRDetectedIssue' => 'FHIRDomainResource/FHIRDetectedIssue.php',
  'DSTU_TWO\\FHIRResource\\FHIRDetectedIssue\\FHIRDetectedIssueMitigation' => 'FHIRResource/FHIRDetectedIssue/FHIRDetectedIssueMitigation.php',
  'DSTU_TWO\\FHIRElement\\FHIRDetectedIssueSeverity' => 'FHIRElement/FHIRDetectedIssueSeverity.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRDevice' => 'FHIRDomainResource/FHIRDevice.php',
  'DSTU_TWO\\FHIRElement\\FHIRDeviceStatus' => 'FHIRElement/FHIRDeviceStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRDeviceComponent' => 'FHIRDomainResource/FHIRDeviceComponent.php',
  'DSTU_TWO\\FHIRResource\\FHIRDeviceComponent\\FHIRDeviceComponentProductionSpecification' => 'FHIRResource/FHIRDeviceComponent/FHIRDeviceComponentProductionSpecification.php',
  'DSTU_TWO\\FHIRElement\\FHIRMeasmnt_Principle' => 'FHIRElement/FHIRMeasmnt_Principle.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRDeviceMetric' => 'FHIRDomainResource/FHIRDeviceMetric.php',
  'DSTU_TWO\\FHIRResource\\FHIRDeviceMetric\\FHIRDeviceMetricCalibration' => 'FHIRResource/FHIRDeviceMetric/FHIRDeviceMetricCalibration.php',
  'DSTU_TWO\\FHIRElement\\FHIRDeviceMetricColor' => 'FHIRElement/FHIRDeviceMetricColor.php',
  'DSTU_TWO\\FHIRElement\\FHIRDeviceMetricCalibrationState' => 'FHIRElement/FHIRDeviceMetricCalibrationState.php',
  'DSTU_TWO\\FHIRElement\\FHIRDeviceMetricCalibrationType' => 'FHIRElement/FHIRDeviceMetricCalibrationType.php',
  'DSTU_TWO\\FHIRElement\\FHIRDeviceMetricCategory' => 'FHIRElement/FHIRDeviceMetricCategory.php',
  'DSTU_TWO\\FHIRElement\\FHIRDeviceMetricOperationalStatus' => 'FHIRElement/FHIRDeviceMetricOperationalStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRDeviceUseRequest' => 'FHIRDomainResource/FHIRDeviceUseRequest.php',
  'DSTU_TWO\\FHIRElement\\FHIRDeviceUseRequestStatus' => 'FHIRElement/FHIRDeviceUseRequestStatus.php',
  'DSTU_TWO\\FHIRElement\\FHIRDeviceUseRequestPriority' => 'FHIRElement/FHIRDeviceUseRequestPriority.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRDeviceUseStatement' => 'FHIRDomainResource/FHIRDeviceUseStatement.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRDiagnosticOrder' => 'FHIRDomainResource/FHIRDiagnosticOrder.php',
  'DSTU_TWO\\FHIRResource\\FHIRDiagnosticOrder\\FHIRDiagnosticOrderEvent' => 'FHIRResource/FHIRDiagnosticOrder/FHIRDiagnosticOrderEvent.php',
  'DSTU_TWO\\FHIRResource\\FHIRDiagnosticOrder\\FHIRDiagnosticOrderItem' => 'FHIRResource/FHIRDiagnosticOrder/FHIRDiagnosticOrderItem.php',
  'DSTU_TWO\\FHIRElement\\FHIRDiagnosticOrderStatus' => 'FHIRElement/FHIRDiagnosticOrderStatus.php',
  'DSTU_TWO\\FHIRElement\\FHIRDiagnosticOrderPriority' => 'FHIRElement/FHIRDiagnosticOrderPriority.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRDiagnosticReport' => 'FHIRDomainResource/FHIRDiagnosticReport.php',
  'DSTU_TWO\\FHIRResource\\FHIRDiagnosticReport\\FHIRDiagnosticReportImage' => 'FHIRResource/FHIRDiagnosticReport/FHIRDiagnosticReportImage.php',
  'DSTU_TWO\\FHIRElement\\FHIRDiagnosticReportStatus' => 'FHIRElement/FHIRDiagnosticReportStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRDocumentManifest' => 'FHIRDomainResource/FHIRDocumentManifest.php',
  'DSTU_TWO\\FHIRResource\\FHIRDocumentManifest\\FHIRDocumentManifestContent' => 'FHIRResource/FHIRDocumentManifest/FHIRDocumentManifestContent.php',
  'DSTU_TWO\\FHIRResource\\FHIRDocumentManifest\\FHIRDocumentManifestRelated' => 'FHIRResource/FHIRDocumentManifest/FHIRDocumentManifestRelated.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRDocumentReference' => 'FHIRDomainResource/FHIRDocumentReference.php',
  'DSTU_TWO\\FHIRResource\\FHIRDocumentReference\\FHIRDocumentReferenceRelatesTo' => 'FHIRResource/FHIRDocumentReference/FHIRDocumentReferenceRelatesTo.php',
  'DSTU_TWO\\FHIRResource\\FHIRDocumentReference\\FHIRDocumentReferenceContent' => 'FHIRResource/FHIRDocumentReference/FHIRDocumentReferenceContent.php',
  'DSTU_TWO\\FHIRResource\\FHIRDocumentReference\\FHIRDocumentReferenceContext' => 'FHIRResource/FHIRDocumentReference/FHIRDocumentReferenceContext.php',
  'DSTU_TWO\\FHIRResource\\FHIRDocumentReference\\FHIRDocumentReferenceRelated' => 'FHIRResource/FHIRDocumentReference/FHIRDocumentReferenceRelated.php',
  'DSTU_TWO\\FHIRElement\\FHIRDocumentRelationshipType' => 'FHIRElement/FHIRDocumentRelationshipType.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIREligibilityRequest' => 'FHIRDomainResource/FHIREligibilityRequest.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIREligibilityResponse' => 'FHIRDomainResource/FHIREligibilityResponse.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIREncounter' => 'FHIRDomainResource/FHIREncounter.php',
  'DSTU_TWO\\FHIRResource\\FHIREncounter\\FHIREncounterStatusHistory' => 'FHIRResource/FHIREncounter/FHIREncounterStatusHistory.php',
  'DSTU_TWO\\FHIRResource\\FHIREncounter\\FHIREncounterParticipant' => 'FHIRResource/FHIREncounter/FHIREncounterParticipant.php',
  'DSTU_TWO\\FHIRResource\\FHIREncounter\\FHIREncounterHospitalization' => 'FHIRResource/FHIREncounter/FHIREncounterHospitalization.php',
  'DSTU_TWO\\FHIRResource\\FHIREncounter\\FHIREncounterLocation' => 'FHIRResource/FHIREncounter/FHIREncounterLocation.php',
  'DSTU_TWO\\FHIRElement\\FHIREncounterLocationStatus' => 'FHIRElement/FHIREncounterLocationStatus.php',
  'DSTU_TWO\\FHIRElement\\FHIREncounterClass' => 'FHIRElement/FHIREncounterClass.php',
  'DSTU_TWO\\FHIRElement\\FHIREncounterState' => 'FHIRElement/FHIREncounterState.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIREnrollmentRequest' => 'FHIRDomainResource/FHIREnrollmentRequest.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIREnrollmentResponse' => 'FHIRDomainResource/FHIREnrollmentResponse.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIREpisodeOfCare' => 'FHIRDomainResource/FHIREpisodeOfCare.php',
  'DSTU_TWO\\FHIRResource\\FHIREpisodeOfCare\\FHIREpisodeOfCareStatusHistory' => 'FHIRResource/FHIREpisodeOfCare/FHIREpisodeOfCareStatusHistory.php',
  'DSTU_TWO\\FHIRResource\\FHIREpisodeOfCare\\FHIREpisodeOfCareCareTeam' => 'FHIRResource/FHIREpisodeOfCare/FHIREpisodeOfCareCareTeam.php',
  'DSTU_TWO\\FHIRElement\\FHIREpisodeOfCareStatus' => 'FHIRElement/FHIREpisodeOfCareStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRExplanationOfBenefit' => 'FHIRDomainResource/FHIRExplanationOfBenefit.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRFamilyMemberHistory' => 'FHIRDomainResource/FHIRFamilyMemberHistory.php',
  'DSTU_TWO\\FHIRResource\\FHIRFamilyMemberHistory\\FHIRFamilyMemberHistoryCondition' => 'FHIRResource/FHIRFamilyMemberHistory/FHIRFamilyMemberHistoryCondition.php',
  'DSTU_TWO\\FHIRElement\\FHIRFamilyHistoryStatus' => 'FHIRElement/FHIRFamilyHistoryStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRFlag' => 'FHIRDomainResource/FHIRFlag.php',
  'DSTU_TWO\\FHIRElement\\FHIRFlagStatus' => 'FHIRElement/FHIRFlagStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRGoal' => 'FHIRDomainResource/FHIRGoal.php',
  'DSTU_TWO\\FHIRResource\\FHIRGoal\\FHIRGoalOutcome' => 'FHIRResource/FHIRGoal/FHIRGoalOutcome.php',
  'DSTU_TWO\\FHIRElement\\FHIRGoalStatus' => 'FHIRElement/FHIRGoalStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRGroup' => 'FHIRDomainResource/FHIRGroup.php',
  'DSTU_TWO\\FHIRResource\\FHIRGroup\\FHIRGroupCharacteristic' => 'FHIRResource/FHIRGroup/FHIRGroupCharacteristic.php',
  'DSTU_TWO\\FHIRResource\\FHIRGroup\\FHIRGroupMember' => 'FHIRResource/FHIRGroup/FHIRGroupMember.php',
  'DSTU_TWO\\FHIRElement\\FHIRGroupType' => 'FHIRElement/FHIRGroupType.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRHealthcareService' => 'FHIRDomainResource/FHIRHealthcareService.php',
  'DSTU_TWO\\FHIRResource\\FHIRHealthcareService\\FHIRHealthcareServiceServiceType' => 'FHIRResource/FHIRHealthcareService/FHIRHealthcareServiceServiceType.php',
  'DSTU_TWO\\FHIRResource\\FHIRHealthcareService\\FHIRHealthcareServiceAvailableTime' => 'FHIRResource/FHIRHealthcareService/FHIRHealthcareServiceAvailableTime.php',
  'DSTU_TWO\\FHIRResource\\FHIRHealthcareService\\FHIRHealthcareServiceNotAvailable' => 'FHIRResource/FHIRHealthcareService/FHIRHealthcareServiceNotAvailable.php',
  'DSTU_TWO\\FHIRElement\\FHIRDaysOfWeek' => 'FHIRElement/FHIRDaysOfWeek.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRImagingObjectSelection' => 'FHIRDomainResource/FHIRImagingObjectSelection.php',
  'DSTU_TWO\\FHIRResource\\FHIRImagingObjectSelection\\FHIRImagingObjectSelectionStudy' => 'FHIRResource/FHIRImagingObjectSelection/FHIRImagingObjectSelectionStudy.php',
  'DSTU_TWO\\FHIRResource\\FHIRImagingObjectSelection\\FHIRImagingObjectSelectionSeries' => 'FHIRResource/FHIRImagingObjectSelection/FHIRImagingObjectSelectionSeries.php',
  'DSTU_TWO\\FHIRResource\\FHIRImagingObjectSelection\\FHIRImagingObjectSelectionInstance' => 'FHIRResource/FHIRImagingObjectSelection/FHIRImagingObjectSelectionInstance.php',
  'DSTU_TWO\\FHIRResource\\FHIRImagingObjectSelection\\FHIRImagingObjectSelectionFrames' => 'FHIRResource/FHIRImagingObjectSelection/FHIRImagingObjectSelectionFrames.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRImagingStudy' => 'FHIRDomainResource/FHIRImagingStudy.php',
  'DSTU_TWO\\FHIRResource\\FHIRImagingStudy\\FHIRImagingStudySeries' => 'FHIRResource/FHIRImagingStudy/FHIRImagingStudySeries.php',
  'DSTU_TWO\\FHIRResource\\FHIRImagingStudy\\FHIRImagingStudyInstance' => 'FHIRResource/FHIRImagingStudy/FHIRImagingStudyInstance.php',
  'DSTU_TWO\\FHIRElement\\FHIRInstanceAvailability' => 'FHIRElement/FHIRInstanceAvailability.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRImmunization' => 'FHIRDomainResource/FHIRImmunization.php',
  'DSTU_TWO\\FHIRResource\\FHIRImmunization\\FHIRImmunizationExplanation' => 'FHIRResource/FHIRImmunization/FHIRImmunizationExplanation.php',
  'DSTU_TWO\\FHIRResource\\FHIRImmunization\\FHIRImmunizationReaction' => 'FHIRResource/FHIRImmunization/FHIRImmunizationReaction.php',
  'DSTU_TWO\\FHIRResource\\FHIRImmunization\\FHIRImmunizationVaccinationProtocol' => 'FHIRResource/FHIRImmunization/FHIRImmunizationVaccinationProtocol.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRImmunizationRecommendation' => 'FHIRDomainResource/FHIRImmunizationRecommendation.php',
  'DSTU_TWO\\FHIRResource\\FHIRImmunizationRecommendation\\FHIRImmunizationRecommendationRecommendation' => 'FHIRResource/FHIRImmunizationRecommendation/FHIRImmunizationRecommendationRecommendation.php',
  'DSTU_TWO\\FHIRResource\\FHIRImmunizationRecommendation\\FHIRImmunizationRecommendationDateCriterion' => 'FHIRResource/FHIRImmunizationRecommendation/FHIRImmunizationRecommendationDateCriterion.php',
  'DSTU_TWO\\FHIRResource\\FHIRImmunizationRecommendation\\FHIRImmunizationRecommendationProtocol' => 'FHIRResource/FHIRImmunizationRecommendation/FHIRImmunizationRecommendationProtocol.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRImplementationGuide' => 'FHIRDomainResource/FHIRImplementationGuide.php',
  'DSTU_TWO\\FHIRResource\\FHIRImplementationGuide\\FHIRImplementationGuideContact' => 'FHIRResource/FHIRImplementationGuide/FHIRImplementationGuideContact.php',
  'DSTU_TWO\\FHIRResource\\FHIRImplementationGuide\\FHIRImplementationGuideDependency' => 'FHIRResource/FHIRImplementationGuide/FHIRImplementationGuideDependency.php',
  'DSTU_TWO\\FHIRResource\\FHIRImplementationGuide\\FHIRImplementationGuidePackage' => 'FHIRResource/FHIRImplementationGuide/FHIRImplementationGuidePackage.php',
  'DSTU_TWO\\FHIRResource\\FHIRImplementationGuide\\FHIRImplementationGuideResource' => 'FHIRResource/FHIRImplementationGuide/FHIRImplementationGuideResource.php',
  'DSTU_TWO\\FHIRResource\\FHIRImplementationGuide\\FHIRImplementationGuideGlobal' => 'FHIRResource/FHIRImplementationGuide/FHIRImplementationGuideGlobal.php',
  'DSTU_TWO\\FHIRResource\\FHIRImplementationGuide\\FHIRImplementationGuidePage' => 'FHIRResource/FHIRImplementationGuide/FHIRImplementationGuidePage.php',
  'DSTU_TWO\\FHIRElement\\FHIRGuideDependencyType' => 'FHIRElement/FHIRGuideDependencyType.php',
  'DSTU_TWO\\FHIRElement\\FHIRGuideResourcePurpose' => 'FHIRElement/FHIRGuideResourcePurpose.php',
  'DSTU_TWO\\FHIRElement\\FHIRGuidePageKind' => 'FHIRElement/FHIRGuidePageKind.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRList' => 'FHIRDomainResource/FHIRList.php',
  'DSTU_TWO\\FHIRResource\\FHIRList\\FHIRListEntry' => 'FHIRResource/FHIRList/FHIRListEntry.php',
  'DSTU_TWO\\FHIRElement\\FHIRListStatus' => 'FHIRElement/FHIRListStatus.php',
  'DSTU_TWO\\FHIRElement\\FHIRListMode' => 'FHIRElement/FHIRListMode.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRLocation' => 'FHIRDomainResource/FHIRLocation.php',
  'DSTU_TWO\\FHIRResource\\FHIRLocation\\FHIRLocationPosition' => 'FHIRResource/FHIRLocation/FHIRLocationPosition.php',
  'DSTU_TWO\\FHIRElement\\FHIRLocationStatus' => 'FHIRElement/FHIRLocationStatus.php',
  'DSTU_TWO\\FHIRElement\\FHIRLocationMode' => 'FHIRElement/FHIRLocationMode.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRMedia' => 'FHIRDomainResource/FHIRMedia.php',
  'DSTU_TWO\\FHIRElement\\FHIRDigitalMediaType' => 'FHIRElement/FHIRDigitalMediaType.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRMedication' => 'FHIRDomainResource/FHIRMedication.php',
  'DSTU_TWO\\FHIRResource\\FHIRMedication\\FHIRMedicationProduct' => 'FHIRResource/FHIRMedication/FHIRMedicationProduct.php',
  'DSTU_TWO\\FHIRResource\\FHIRMedication\\FHIRMedicationIngredient' => 'FHIRResource/FHIRMedication/FHIRMedicationIngredient.php',
  'DSTU_TWO\\FHIRResource\\FHIRMedication\\FHIRMedicationBatch' => 'FHIRResource/FHIRMedication/FHIRMedicationBatch.php',
  'DSTU_TWO\\FHIRResource\\FHIRMedication\\FHIRMedicationPackage' => 'FHIRResource/FHIRMedication/FHIRMedicationPackage.php',
  'DSTU_TWO\\FHIRResource\\FHIRMedication\\FHIRMedicationContent' => 'FHIRResource/FHIRMedication/FHIRMedicationContent.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRMedicationAdministration' => 'FHIRDomainResource/FHIRMedicationAdministration.php',
  'DSTU_TWO\\FHIRResource\\FHIRMedicationAdministration\\FHIRMedicationAdministrationDosage' => 'FHIRResource/FHIRMedicationAdministration/FHIRMedicationAdministrationDosage.php',
  'DSTU_TWO\\FHIRElement\\FHIRMedicationAdministrationStatus' => 'FHIRElement/FHIRMedicationAdministrationStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRMedicationDispense' => 'FHIRDomainResource/FHIRMedicationDispense.php',
  'DSTU_TWO\\FHIRResource\\FHIRMedicationDispense\\FHIRMedicationDispenseDosageInstruction' => 'FHIRResource/FHIRMedicationDispense/FHIRMedicationDispenseDosageInstruction.php',
  'DSTU_TWO\\FHIRResource\\FHIRMedicationDispense\\FHIRMedicationDispenseSubstitution' => 'FHIRResource/FHIRMedicationDispense/FHIRMedicationDispenseSubstitution.php',
  'DSTU_TWO\\FHIRElement\\FHIRMedicationDispenseStatus' => 'FHIRElement/FHIRMedicationDispenseStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRMedicationOrder' => 'FHIRDomainResource/FHIRMedicationOrder.php',
  'DSTU_TWO\\FHIRResource\\FHIRMedicationOrder\\FHIRMedicationOrderDosageInstruction' => 'FHIRResource/FHIRMedicationOrder/FHIRMedicationOrderDosageInstruction.php',
  'DSTU_TWO\\FHIRResource\\FHIRMedicationOrder\\FHIRMedicationOrderDispenseRequest' => 'FHIRResource/FHIRMedicationOrder/FHIRMedicationOrderDispenseRequest.php',
  'DSTU_TWO\\FHIRResource\\FHIRMedicationOrder\\FHIRMedicationOrderSubstitution' => 'FHIRResource/FHIRMedicationOrder/FHIRMedicationOrderSubstitution.php',
  'DSTU_TWO\\FHIRElement\\FHIRMedicationOrderStatus' => 'FHIRElement/FHIRMedicationOrderStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRMedicationPrescription' => 'FHIRDomainResource/FHIRMedicationPrescription.php',
  'DSTU_TWO\\FHIRResource\\FHIRMedicationPrescription\\FHIRMedicationPrescriptionDosageInstruction' => 'FHIRResource/FHIRMedicationPrescription/FHIRMedicationPrescriptionDosageInstruction.php',
  'DSTU_TWO\\FHIRResource\\FHIRMedicationPrescription\\FHIRMedicationPrescriptionDispense' => 'FHIRResource/FHIRMedicationPrescription/FHIRMedicationPrescriptionDispense.php',
  'DSTU_TWO\\FHIRResource\\FHIRMedicationPrescription\\FHIRMedicationPrescriptionSubstitution' => 'FHIRResource/FHIRMedicationPrescription/FHIRMedicationPrescriptionSubstitution.php',
  'DSTU_TWO\\FHIRElement\\FHIRMedicationPrescriptionStatus' => 'FHIRElement/FHIRMedicationPrescriptionStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRMedicationStatement' => 'FHIRDomainResource/FHIRMedicationStatement.php',
  'DSTU_TWO\\FHIRResource\\FHIRMedicationStatement\\FHIRMedicationStatementDosage' => 'FHIRResource/FHIRMedicationStatement/FHIRMedicationStatementDosage.php',
  'DSTU_TWO\\FHIRElement\\FHIRMedicationStatementStatus' => 'FHIRElement/FHIRMedicationStatementStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRMessageHeader' => 'FHIRDomainResource/FHIRMessageHeader.php',
  'DSTU_TWO\\FHIRResource\\FHIRMessageHeader\\FHIRMessageHeaderResponse' => 'FHIRResource/FHIRMessageHeader/FHIRMessageHeaderResponse.php',
  'DSTU_TWO\\FHIRResource\\FHIRMessageHeader\\FHIRMessageHeaderSource' => 'FHIRResource/FHIRMessageHeader/FHIRMessageHeaderSource.php',
  'DSTU_TWO\\FHIRResource\\FHIRMessageHeader\\FHIRMessageHeaderDestination' => 'FHIRResource/FHIRMessageHeader/FHIRMessageHeaderDestination.php',
  'DSTU_TWO\\FHIRElement\\FHIRResponseType' => 'FHIRElement/FHIRResponseType.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRNamingSystem' => 'FHIRDomainResource/FHIRNamingSystem.php',
  'DSTU_TWO\\FHIRResource\\FHIRNamingSystem\\FHIRNamingSystemContact' => 'FHIRResource/FHIRNamingSystem/FHIRNamingSystemContact.php',
  'DSTU_TWO\\FHIRResource\\FHIRNamingSystem\\FHIRNamingSystemUniqueId' => 'FHIRResource/FHIRNamingSystem/FHIRNamingSystemUniqueId.php',
  'DSTU_TWO\\FHIRElement\\FHIRNamingSystemType' => 'FHIRElement/FHIRNamingSystemType.php',
  'DSTU_TWO\\FHIRElement\\FHIRNamingSystemIdentifierType' => 'FHIRElement/FHIRNamingSystemIdentifierType.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRNutritionOrder' => 'FHIRDomainResource/FHIRNutritionOrder.php',
  'DSTU_TWO\\FHIRResource\\FHIRNutritionOrder\\FHIRNutritionOrderOralDiet' => 'FHIRResource/FHIRNutritionOrder/FHIRNutritionOrderOralDiet.php',
  'DSTU_TWO\\FHIRResource\\FHIRNutritionOrder\\FHIRNutritionOrderNutrient' => 'FHIRResource/FHIRNutritionOrder/FHIRNutritionOrderNutrient.php',
  'DSTU_TWO\\FHIRResource\\FHIRNutritionOrder\\FHIRNutritionOrderTexture' => 'FHIRResource/FHIRNutritionOrder/FHIRNutritionOrderTexture.php',
  'DSTU_TWO\\FHIRResource\\FHIRNutritionOrder\\FHIRNutritionOrderSupplement' => 'FHIRResource/FHIRNutritionOrder/FHIRNutritionOrderSupplement.php',
  'DSTU_TWO\\FHIRResource\\FHIRNutritionOrder\\FHIRNutritionOrderEnteralFormula' => 'FHIRResource/FHIRNutritionOrder/FHIRNutritionOrderEnteralFormula.php',
  'DSTU_TWO\\FHIRResource\\FHIRNutritionOrder\\FHIRNutritionOrderAdministration' => 'FHIRResource/FHIRNutritionOrder/FHIRNutritionOrderAdministration.php',
  'DSTU_TWO\\FHIRElement\\FHIRNutritionOrderStatus' => 'FHIRElement/FHIRNutritionOrderStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRObservation' => 'FHIRDomainResource/FHIRObservation.php',
  'DSTU_TWO\\FHIRResource\\FHIRObservation\\FHIRObservationReferenceRange' => 'FHIRResource/FHIRObservation/FHIRObservationReferenceRange.php',
  'DSTU_TWO\\FHIRResource\\FHIRObservation\\FHIRObservationRelated' => 'FHIRResource/FHIRObservation/FHIRObservationRelated.php',
  'DSTU_TWO\\FHIRResource\\FHIRObservation\\FHIRObservationComponent' => 'FHIRResource/FHIRObservation/FHIRObservationComponent.php',
  'DSTU_TWO\\FHIRElement\\FHIRObservationStatus' => 'FHIRElement/FHIRObservationStatus.php',
  'DSTU_TWO\\FHIRElement\\FHIRObservationRelationshipType' => 'FHIRElement/FHIRObservationRelationshipType.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIROperationDefinition' => 'FHIRDomainResource/FHIROperationDefinition.php',
  'DSTU_TWO\\FHIRResource\\FHIROperationDefinition\\FHIROperationDefinitionContact' => 'FHIRResource/FHIROperationDefinition/FHIROperationDefinitionContact.php',
  'DSTU_TWO\\FHIRResource\\FHIROperationDefinition\\FHIROperationDefinitionParameter' => 'FHIRResource/FHIROperationDefinition/FHIROperationDefinitionParameter.php',
  'DSTU_TWO\\FHIRResource\\FHIROperationDefinition\\FHIROperationDefinitionBinding' => 'FHIRResource/FHIROperationDefinition/FHIROperationDefinitionBinding.php',
  'DSTU_TWO\\FHIRElement\\FHIROperationParameterUse' => 'FHIRElement/FHIROperationParameterUse.php',
  'DSTU_TWO\\FHIRElement\\FHIROperationKind' => 'FHIRElement/FHIROperationKind.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIROperationOutcome' => 'FHIRDomainResource/FHIROperationOutcome.php',
  'DSTU_TWO\\FHIRResource\\FHIROperationOutcome\\FHIROperationOutcomeIssue' => 'FHIRResource/FHIROperationOutcome/FHIROperationOutcomeIssue.php',
  'DSTU_TWO\\FHIRElement\\FHIRIssueType' => 'FHIRElement/FHIRIssueType.php',
  'DSTU_TWO\\FHIRElement\\FHIRIssueSeverity' => 'FHIRElement/FHIRIssueSeverity.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIROrder' => 'FHIRDomainResource/FHIROrder.php',
  'DSTU_TWO\\FHIRResource\\FHIROrder\\FHIROrderWhen' => 'FHIRResource/FHIROrder/FHIROrderWhen.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIROrderResponse' => 'FHIRDomainResource/FHIROrderResponse.php',
  'DSTU_TWO\\FHIRElement\\FHIROrderStatus' => 'FHIRElement/FHIROrderStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIROrganization' => 'FHIRDomainResource/FHIROrganization.php',
  'DSTU_TWO\\FHIRResource\\FHIROrganization\\FHIROrganizationContact' => 'FHIRResource/FHIROrganization/FHIROrganizationContact.php',
  'DSTU_TWO\\FHIRResource\\FHIRParameters' => 'FHIRResource/FHIRParameters.php',
  'DSTU_TWO\\FHIRResource\\FHIRParameters\\FHIRParametersParameter' => 'FHIRResource/FHIRParameters/FHIRParametersParameter.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRPatient' => 'FHIRDomainResource/FHIRPatient.php',
  'DSTU_TWO\\FHIRResource\\FHIRPatient\\FHIRPatientContact' => 'FHIRResource/FHIRPatient/FHIRPatientContact.php',
  'DSTU_TWO\\FHIRResource\\FHIRPatient\\FHIRPatientAnimal' => 'FHIRResource/FHIRPatient/FHIRPatientAnimal.php',
  'DSTU_TWO\\FHIRResource\\FHIRPatient\\FHIRPatientCommunication' => 'FHIRResource/FHIRPatient/FHIRPatientCommunication.php',
  'DSTU_TWO\\FHIRResource\\FHIRPatient\\FHIRPatientLink' => 'FHIRResource/FHIRPatient/FHIRPatientLink.php',
  'DSTU_TWO\\FHIRElement\\FHIRLinkType' => 'FHIRElement/FHIRLinkType.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRPaymentNotice' => 'FHIRDomainResource/FHIRPaymentNotice.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRPaymentReconciliation' => 'FHIRDomainResource/FHIRPaymentReconciliation.php',
  'DSTU_TWO\\FHIRResource\\FHIRPaymentReconciliation\\FHIRPaymentReconciliationDetail' => 'FHIRResource/FHIRPaymentReconciliation/FHIRPaymentReconciliationDetail.php',
  'DSTU_TWO\\FHIRResource\\FHIRPaymentReconciliation\\FHIRPaymentReconciliationNote' => 'FHIRResource/FHIRPaymentReconciliation/FHIRPaymentReconciliationNote.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRPerson' => 'FHIRDomainResource/FHIRPerson.php',
  'DSTU_TWO\\FHIRResource\\FHIRPerson\\FHIRPersonLink' => 'FHIRResource/FHIRPerson/FHIRPersonLink.php',
  'DSTU_TWO\\FHIRElement\\FHIRIdentityAssuranceLevel' => 'FHIRElement/FHIRIdentityAssuranceLevel.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRPractitioner' => 'FHIRDomainResource/FHIRPractitioner.php',
  'DSTU_TWO\\FHIRResource\\FHIRPractitioner\\FHIRPractitionerPractitionerRole' => 'FHIRResource/FHIRPractitioner/FHIRPractitionerPractitionerRole.php',
  'DSTU_TWO\\FHIRResource\\FHIRPractitioner\\FHIRPractitionerQualification' => 'FHIRResource/FHIRPractitioner/FHIRPractitionerQualification.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRProcedure' => 'FHIRDomainResource/FHIRProcedure.php',
  'DSTU_TWO\\FHIRResource\\FHIRProcedure\\FHIRProcedurePerformer' => 'FHIRResource/FHIRProcedure/FHIRProcedurePerformer.php',
  'DSTU_TWO\\FHIRResource\\FHIRProcedure\\FHIRProcedureFocalDevice' => 'FHIRResource/FHIRProcedure/FHIRProcedureFocalDevice.php',
  'DSTU_TWO\\FHIRElement\\FHIRProcedureStatus' => 'FHIRElement/FHIRProcedureStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRProcedureRequest' => 'FHIRDomainResource/FHIRProcedureRequest.php',
  'DSTU_TWO\\FHIRElement\\FHIRProcedureRequestPriority' => 'FHIRElement/FHIRProcedureRequestPriority.php',
  'DSTU_TWO\\FHIRElement\\FHIRProcedureRequestStatus' => 'FHIRElement/FHIRProcedureRequestStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRProcessRequest' => 'FHIRDomainResource/FHIRProcessRequest.php',
  'DSTU_TWO\\FHIRResource\\FHIRProcessRequest\\FHIRProcessRequestItem' => 'FHIRResource/FHIRProcessRequest/FHIRProcessRequestItem.php',
  'DSTU_TWO\\FHIRElement\\FHIRActionList' => 'FHIRElement/FHIRActionList.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRProcessResponse' => 'FHIRDomainResource/FHIRProcessResponse.php',
  'DSTU_TWO\\FHIRResource\\FHIRProcessResponse\\FHIRProcessResponseNotes' => 'FHIRResource/FHIRProcessResponse/FHIRProcessResponseNotes.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRProvenance' => 'FHIRDomainResource/FHIRProvenance.php',
  'DSTU_TWO\\FHIRResource\\FHIRProvenance\\FHIRProvenanceAgent' => 'FHIRResource/FHIRProvenance/FHIRProvenanceAgent.php',
  'DSTU_TWO\\FHIRResource\\FHIRProvenance\\FHIRProvenanceRelatedAgent' => 'FHIRResource/FHIRProvenance/FHIRProvenanceRelatedAgent.php',
  'DSTU_TWO\\FHIRResource\\FHIRProvenance\\FHIRProvenanceEntity' => 'FHIRResource/FHIRProvenance/FHIRProvenanceEntity.php',
  'DSTU_TWO\\FHIRElement\\FHIRProvenanceEntityRole' => 'FHIRElement/FHIRProvenanceEntityRole.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRQuestionnaire' => 'FHIRDomainResource/FHIRQuestionnaire.php',
  'DSTU_TWO\\FHIRResource\\FHIRQuestionnaire\\FHIRQuestionnaireGroup' => 'FHIRResource/FHIRQuestionnaire/FHIRQuestionnaireGroup.php',
  'DSTU_TWO\\FHIRResource\\FHIRQuestionnaire\\FHIRQuestionnaireQuestion' => 'FHIRResource/FHIRQuestionnaire/FHIRQuestionnaireQuestion.php',
  'DSTU_TWO\\FHIRElement\\FHIRQuestionnaireStatus' => 'FHIRElement/FHIRQuestionnaireStatus.php',
  'DSTU_TWO\\FHIRElement\\FHIRAnswerFormat' => 'FHIRElement/FHIRAnswerFormat.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRQuestionnaireAnswers' => 'FHIRDomainResource/FHIRQuestionnaireAnswers.php',
  'DSTU_TWO\\FHIRResource\\FHIRQuestionnaireAnswers\\FHIRQuestionnaireAnswersGroup' => 'FHIRResource/FHIRQuestionnaireAnswers/FHIRQuestionnaireAnswersGroup.php',
  'DSTU_TWO\\FHIRResource\\FHIRQuestionnaireAnswers\\FHIRQuestionnaireAnswersQuestion' => 'FHIRResource/FHIRQuestionnaireAnswers/FHIRQuestionnaireAnswersQuestion.php',
  'DSTU_TWO\\FHIRResource\\FHIRQuestionnaireAnswers\\FHIRQuestionnaireAnswersAnswer' => 'FHIRResource/FHIRQuestionnaireAnswers/FHIRQuestionnaireAnswersAnswer.php',
  'DSTU_TWO\\FHIRElement\\FHIRQuestionnaireAnswersStatus' => 'FHIRElement/FHIRQuestionnaireAnswersStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRQuestionnaireResponse' => 'FHIRDomainResource/FHIRQuestionnaireResponse.php',
  'DSTU_TWO\\FHIRResource\\FHIRQuestionnaireResponse\\FHIRQuestionnaireResponseGroup' => 'FHIRResource/FHIRQuestionnaireResponse/FHIRQuestionnaireResponseGroup.php',
  'DSTU_TWO\\FHIRResource\\FHIRQuestionnaireResponse\\FHIRQuestionnaireResponseQuestion' => 'FHIRResource/FHIRQuestionnaireResponse/FHIRQuestionnaireResponseQuestion.php',
  'DSTU_TWO\\FHIRResource\\FHIRQuestionnaireResponse\\FHIRQuestionnaireResponseAnswer' => 'FHIRResource/FHIRQuestionnaireResponse/FHIRQuestionnaireResponseAnswer.php',
  'DSTU_TWO\\FHIRElement\\FHIRQuestionnaireResponseStatus' => 'FHIRElement/FHIRQuestionnaireResponseStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRReferralRequest' => 'FHIRDomainResource/FHIRReferralRequest.php',
  'DSTU_TWO\\FHIRElement\\FHIRReferralStatus' => 'FHIRElement/FHIRReferralStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRRelatedPerson' => 'FHIRDomainResource/FHIRRelatedPerson.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRRiskAssessment' => 'FHIRDomainResource/FHIRRiskAssessment.php',
  'DSTU_TWO\\FHIRResource\\FHIRRiskAssessment\\FHIRRiskAssessmentPrediction' => 'FHIRResource/FHIRRiskAssessment/FHIRRiskAssessmentPrediction.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRSchedule' => 'FHIRDomainResource/FHIRSchedule.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRSearchParameter' => 'FHIRDomainResource/FHIRSearchParameter.php',
  'DSTU_TWO\\FHIRResource\\FHIRSearchParameter\\FHIRSearchParameterContact' => 'FHIRResource/FHIRSearchParameter/FHIRSearchParameterContact.php',
  'DSTU_TWO\\FHIRElement\\FHIRXPathUsageType' => 'FHIRElement/FHIRXPathUsageType.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRSlot' => 'FHIRDomainResource/FHIRSlot.php',
  'DSTU_TWO\\FHIRElement\\FHIRSlotStatus' => 'FHIRElement/FHIRSlotStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRSpecimen' => 'FHIRDomainResource/FHIRSpecimen.php',
  'DSTU_TWO\\FHIRResource\\FHIRSpecimen\\FHIRSpecimenCollection' => 'FHIRResource/FHIRSpecimen/FHIRSpecimenCollection.php',
  'DSTU_TWO\\FHIRResource\\FHIRSpecimen\\FHIRSpecimenTreatment' => 'FHIRResource/FHIRSpecimen/FHIRSpecimenTreatment.php',
  'DSTU_TWO\\FHIRResource\\FHIRSpecimen\\FHIRSpecimenContainer' => 'FHIRResource/FHIRSpecimen/FHIRSpecimenContainer.php',
  'DSTU_TWO\\FHIRElement\\FHIRSpecimenStatus' => 'FHIRElement/FHIRSpecimenStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRStructureDefinition' => 'FHIRDomainResource/FHIRStructureDefinition.php',
  'DSTU_TWO\\FHIRResource\\FHIRStructureDefinition\\FHIRStructureDefinitionContact' => 'FHIRResource/FHIRStructureDefinition/FHIRStructureDefinitionContact.php',
  'DSTU_TWO\\FHIRResource\\FHIRStructureDefinition\\FHIRStructureDefinitionMapping' => 'FHIRResource/FHIRStructureDefinition/FHIRStructureDefinitionMapping.php',
  'DSTU_TWO\\FHIRResource\\FHIRStructureDefinition\\FHIRStructureDefinitionSnapshot' => 'FHIRResource/FHIRStructureDefinition/FHIRStructureDefinitionSnapshot.php',
  'DSTU_TWO\\FHIRResource\\FHIRStructureDefinition\\FHIRStructureDefinitionDifferential' => 'FHIRResource/FHIRStructureDefinition/FHIRStructureDefinitionDifferential.php',
  'DSTU_TWO\\FHIRElement\\FHIRStructureDefinitionKind' => 'FHIRElement/FHIRStructureDefinitionKind.php',
  'DSTU_TWO\\FHIRElement\\FHIRExtensionContext' => 'FHIRElement/FHIRExtensionContext.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRSubscription' => 'FHIRDomainResource/FHIRSubscription.php',
  'DSTU_TWO\\FHIRResource\\FHIRSubscription\\FHIRSubscriptionChannel' => 'FHIRResource/FHIRSubscription/FHIRSubscriptionChannel.php',
  'DSTU_TWO\\FHIRElement\\FHIRSubscriptionStatus' => 'FHIRElement/FHIRSubscriptionStatus.php',
  'DSTU_TWO\\FHIRElement\\FHIRSubscriptionChannelType' => 'FHIRElement/FHIRSubscriptionChannelType.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRSubstance' => 'FHIRDomainResource/FHIRSubstance.php',
  'DSTU_TWO\\FHIRResource\\FHIRSubstance\\FHIRSubstanceInstance' => 'FHIRResource/FHIRSubstance/FHIRSubstanceInstance.php',
  'DSTU_TWO\\FHIRResource\\FHIRSubstance\\FHIRSubstanceIngredient' => 'FHIRResource/FHIRSubstance/FHIRSubstanceIngredient.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRSupply' => 'FHIRDomainResource/FHIRSupply.php',
  'DSTU_TWO\\FHIRResource\\FHIRSupply\\FHIRSupplyDispense' => 'FHIRResource/FHIRSupply/FHIRSupplyDispense.php',
  'DSTU_TWO\\FHIRElement\\FHIRSupplyDispenseStatus' => 'FHIRElement/FHIRSupplyDispenseStatus.php',
  'DSTU_TWO\\FHIRElement\\FHIRSupplyStatus' => 'FHIRElement/FHIRSupplyStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRSupplyDelivery' => 'FHIRDomainResource/FHIRSupplyDelivery.php',
  'DSTU_TWO\\FHIRElement\\FHIRSupplyDeliveryStatus' => 'FHIRElement/FHIRSupplyDeliveryStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRSupplyRequest' => 'FHIRDomainResource/FHIRSupplyRequest.php',
  'DSTU_TWO\\FHIRResource\\FHIRSupplyRequest\\FHIRSupplyRequestWhen' => 'FHIRResource/FHIRSupplyRequest/FHIRSupplyRequestWhen.php',
  'DSTU_TWO\\FHIRElement\\FHIRSupplyRequestStatus' => 'FHIRElement/FHIRSupplyRequestStatus.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRTestScript' => 'FHIRDomainResource/FHIRTestScript.php',
  'DSTU_TWO\\FHIRResource\\FHIRTestScript\\FHIRTestScriptContact' => 'FHIRResource/FHIRTestScript/FHIRTestScriptContact.php',
  'DSTU_TWO\\FHIRResource\\FHIRTestScript\\FHIRTestScriptMetadata' => 'FHIRResource/FHIRTestScript/FHIRTestScriptMetadata.php',
  'DSTU_TWO\\FHIRResource\\FHIRTestScript\\FHIRTestScriptLink' => 'FHIRResource/FHIRTestScript/FHIRTestScriptLink.php',
  'DSTU_TWO\\FHIRResource\\FHIRTestScript\\FHIRTestScriptCapability' => 'FHIRResource/FHIRTestScript/FHIRTestScriptCapability.php',
  'DSTU_TWO\\FHIRResource\\FHIRTestScript\\FHIRTestScriptFixture' => 'FHIRResource/FHIRTestScript/FHIRTestScriptFixture.php',
  'DSTU_TWO\\FHIRResource\\FHIRTestScript\\FHIRTestScriptVariable' => 'FHIRResource/FHIRTestScript/FHIRTestScriptVariable.php',
  'DSTU_TWO\\FHIRResource\\FHIRTestScript\\FHIRTestScriptSetup' => 'FHIRResource/FHIRTestScript/FHIRTestScriptSetup.php',
  'DSTU_TWO\\FHIRResource\\FHIRTestScript\\FHIRTestScriptAction' => 'FHIRResource/FHIRTestScript/FHIRTestScriptAction.php',
  'DSTU_TWO\\FHIRResource\\FHIRTestScript\\FHIRTestScriptOperation' => 'FHIRResource/FHIRTestScript/FHIRTestScriptOperation.php',
  'DSTU_TWO\\FHIRResource\\FHIRTestScript\\FHIRTestScriptRequestHeader' => 'FHIRResource/FHIRTestScript/FHIRTestScriptRequestHeader.php',
  'DSTU_TWO\\FHIRResource\\FHIRTestScript\\FHIRTestScriptAssert' => 'FHIRResource/FHIRTestScript/FHIRTestScriptAssert.php',
  'DSTU_TWO\\FHIRResource\\FHIRTestScript\\FHIRTestScriptTest' => 'FHIRResource/FHIRTestScript/FHIRTestScriptTest.php',
  'DSTU_TWO\\FHIRResource\\FHIRTestScript\\FHIRTestScriptAction1' => 'FHIRResource/FHIRTestScript/FHIRTestScriptAction1.php',
  'DSTU_TWO\\FHIRResource\\FHIRTestScript\\FHIRTestScriptTeardown' => 'FHIRResource/FHIRTestScript/FHIRTestScriptTeardown.php',
  'DSTU_TWO\\FHIRResource\\FHIRTestScript\\FHIRTestScriptAction2' => 'FHIRResource/FHIRTestScript/FHIRTestScriptAction2.php',
  'DSTU_TWO\\FHIRElement\\FHIRAssertionDirectionType' => 'FHIRElement/FHIRAssertionDirectionType.php',
  'DSTU_TWO\\FHIRElement\\FHIRAssertionResponseTypes' => 'FHIRElement/FHIRAssertionResponseTypes.php',
  'DSTU_TWO\\FHIRElement\\FHIRAssertionOperatorType' => 'FHIRElement/FHIRAssertionOperatorType.php',
  'DSTU_TWO\\FHIRElement\\FHIRContentType' => 'FHIRElement/FHIRContentType.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRValueSet' => 'FHIRDomainResource/FHIRValueSet.php',
  'DSTU_TWO\\FHIRResource\\FHIRValueSet\\FHIRValueSetContact' => 'FHIRResource/FHIRValueSet/FHIRValueSetContact.php',
  'DSTU_TWO\\FHIRResource\\FHIRValueSet\\FHIRValueSetCodeSystem' => 'FHIRResource/FHIRValueSet/FHIRValueSetCodeSystem.php',
  'DSTU_TWO\\FHIRResource\\FHIRValueSet\\FHIRValueSetConcept' => 'FHIRResource/FHIRValueSet/FHIRValueSetConcept.php',
  'DSTU_TWO\\FHIRResource\\FHIRValueSet\\FHIRValueSetDesignation' => 'FHIRResource/FHIRValueSet/FHIRValueSetDesignation.php',
  'DSTU_TWO\\FHIRResource\\FHIRValueSet\\FHIRValueSetCompose' => 'FHIRResource/FHIRValueSet/FHIRValueSetCompose.php',
  'DSTU_TWO\\FHIRResource\\FHIRValueSet\\FHIRValueSetInclude' => 'FHIRResource/FHIRValueSet/FHIRValueSetInclude.php',
  'DSTU_TWO\\FHIRResource\\FHIRValueSet\\FHIRValueSetConcept1' => 'FHIRResource/FHIRValueSet/FHIRValueSetConcept1.php',
  'DSTU_TWO\\FHIRResource\\FHIRValueSet\\FHIRValueSetFilter' => 'FHIRResource/FHIRValueSet/FHIRValueSetFilter.php',
  'DSTU_TWO\\FHIRResource\\FHIRValueSet\\FHIRValueSetExpansion' => 'FHIRResource/FHIRValueSet/FHIRValueSetExpansion.php',
  'DSTU_TWO\\FHIRResource\\FHIRValueSet\\FHIRValueSetParameter' => 'FHIRResource/FHIRValueSet/FHIRValueSetParameter.php',
  'DSTU_TWO\\FHIRResource\\FHIRValueSet\\FHIRValueSetContains' => 'FHIRResource/FHIRValueSet/FHIRValueSetContains.php',
  'DSTU_TWO\\FHIRElement\\FHIRFilterOperator' => 'FHIRElement/FHIRFilterOperator.php',
  'DSTU_TWO\\FHIRDomainResource\\FHIRVisionPrescription' => 'FHIRDomainResource/FHIRVisionPrescription.php',
  'DSTU_TWO\\FHIRResource\\FHIRVisionPrescription\\FHIRVisionPrescriptionDispense' => 'FHIRResource/FHIRVisionPrescription/FHIRVisionPrescriptionDispense.php',
  'DSTU_TWO\\FHIRElement\\FHIRVisionBase' => 'FHIRElement/FHIRVisionBase.php',
  'DSTU_TWO\\FHIRElement\\FHIRVisionEyes' => 'FHIRElement/FHIRVisionEyes.php',
);

    /** @var bool */
    private static $_registered = false;

    /**
     * @return bool
     * @throws \Exception
     */
    public static function register()
    {
        if (self::$_registered)
            return self::$_registered;
        return self::$_registered = spl_autoload_register(array(__CLASS__, 'loadClass'), true);
    }

    /**
     * @return bool
     */
    public static function unregister()
    {
        self::$_registered = !spl_autoload_unregister(array(__CLASS__, 'loadClass'));
        return !self::$_registered;
    }

    /**
     * Please see associated documentation for more information on what this method looks for.
     *
     * @param string $class
     * @return bool|null
     */
    public static function loadClass($class)
    {
        if (isset(self::$_classMap[$class]))
            return (bool)require sprintf('%s/%s', self::ROOT_DIR, self::$_classMap[$class]);
        return null;
    }
}